// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: TransLog.proto

package com.fss.fo.mserver.exchange;

public final class TransLogProtos {
  private TransLogProtos() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public interface TransLogOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // optional string Id = 1;
    /**
     * <code>optional string Id = 1;</code>
     */
    boolean hasId();
    /**
     * <code>optional string Id = 1;</code>
     */
    java.lang.String getId();
    /**
     * <code>optional string Id = 1;</code>
     */
    com.google.protobuf.ByteString
        getIdBytes();

    // optional int32 sequenceMsg = 2;
    /**
     * <code>optional int32 sequenceMsg = 2;</code>
     */
    boolean hasSequenceMsg();
    /**
     * <code>optional int32 sequenceMsg = 2;</code>
     */
    int getSequenceMsg();

    // optional string tradingdate = 3;
    /**
     * <code>optional string tradingdate = 3;</code>
     */
    boolean hasTradingdate();
    /**
     * <code>optional string tradingdate = 3;</code>
     */
    java.lang.String getTradingdate();
    /**
     * <code>optional string tradingdate = 3;</code>
     */
    com.google.protobuf.ByteString
        getTradingdateBytes();

    // optional string symbol = 4;
    /**
     * <code>optional string symbol = 4;</code>
     */
    boolean hasSymbol();
    /**
     * <code>optional string symbol = 4;</code>
     */
    java.lang.String getSymbol();
    /**
     * <code>optional string symbol = 4;</code>
     */
    com.google.protobuf.ByteString
        getSymbolBytes();

    // optional string formattedTime = 5;
    /**
     * <code>optional string formattedTime = 5;</code>
     */
    boolean hasFormattedTime();
    /**
     * <code>optional string formattedTime = 5;</code>
     */
    java.lang.String getFormattedTime();
    /**
     * <code>optional string formattedTime = 5;</code>
     */
    com.google.protobuf.ByteString
        getFormattedTimeBytes();

    // optional string lastColor = 6;
    /**
     * <code>optional string lastColor = 6;</code>
     */
    boolean hasLastColor();
    /**
     * <code>optional string lastColor = 6;</code>
     */
    java.lang.String getLastColor();
    /**
     * <code>optional string lastColor = 6;</code>
     */
    com.google.protobuf.ByteString
        getLastColorBytes();

    // optional string formattedMatchPrice = 7;
    /**
     * <code>optional string formattedMatchPrice = 7;</code>
     */
    boolean hasFormattedMatchPrice();
    /**
     * <code>optional string formattedMatchPrice = 7;</code>
     */
    java.lang.String getFormattedMatchPrice();
    /**
     * <code>optional string formattedMatchPrice = 7;</code>
     */
    com.google.protobuf.ByteString
        getFormattedMatchPriceBytes();

    // optional string changeColor = 8;
    /**
     * <code>optional string changeColor = 8;</code>
     */
    boolean hasChangeColor();
    /**
     * <code>optional string changeColor = 8;</code>
     */
    java.lang.String getChangeColor();
    /**
     * <code>optional string changeColor = 8;</code>
     */
    com.google.protobuf.ByteString
        getChangeColorBytes();

    // optional string formattedChangeValue = 9;
    /**
     * <code>optional string formattedChangeValue = 9;</code>
     */
    boolean hasFormattedChangeValue();
    /**
     * <code>optional string formattedChangeValue = 9;</code>
     */
    java.lang.String getFormattedChangeValue();
    /**
     * <code>optional string formattedChangeValue = 9;</code>
     */
    com.google.protobuf.ByteString
        getFormattedChangeValueBytes();

    // optional string formattedVol = 10;
    /**
     * <code>optional string formattedVol = 10;</code>
     */
    boolean hasFormattedVol();
    /**
     * <code>optional string formattedVol = 10;</code>
     */
    java.lang.String getFormattedVol();
    /**
     * <code>optional string formattedVol = 10;</code>
     */
    com.google.protobuf.ByteString
        getFormattedVolBytes();

    // optional string formattedAccVol = 11;
    /**
     * <code>optional string formattedAccVol = 11;</code>
     */
    boolean hasFormattedAccVol();
    /**
     * <code>optional string formattedAccVol = 11;</code>
     */
    java.lang.String getFormattedAccVol();
    /**
     * <code>optional string formattedAccVol = 11;</code>
     */
    com.google.protobuf.ByteString
        getFormattedAccVolBytes();

    // optional string formattedAccVal = 12;
    /**
     * <code>optional string formattedAccVal = 12;</code>
     */
    boolean hasFormattedAccVal();
    /**
     * <code>optional string formattedAccVal = 12;</code>
     */
    java.lang.String getFormattedAccVal();
    /**
     * <code>optional string formattedAccVal = 12;</code>
     */
    com.google.protobuf.ByteString
        getFormattedAccValBytes();
  }
  /**
   * Protobuf type {@code com.fss.fo.mserver.exchange.TransLog}
   */
  public static final class TransLog extends
      com.google.protobuf.GeneratedMessage
      implements TransLogOrBuilder {
    // Use TransLog.newBuilder() to construct.
    private TransLog(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private TransLog(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final TransLog defaultInstance;
    public static TransLog getDefaultInstance() {
      return defaultInstance;
    }

    public TransLog getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private TransLog(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              bitField0_ |= 0x00000001;
              id_ = input.readBytes();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              sequenceMsg_ = input.readInt32();
              break;
            }
            case 26: {
              bitField0_ |= 0x00000004;
              tradingdate_ = input.readBytes();
              break;
            }
            case 34: {
              bitField0_ |= 0x00000008;
              symbol_ = input.readBytes();
              break;
            }
            case 42: {
              bitField0_ |= 0x00000010;
              formattedTime_ = input.readBytes();
              break;
            }
            case 50: {
              bitField0_ |= 0x00000020;
              lastColor_ = input.readBytes();
              break;
            }
            case 58: {
              bitField0_ |= 0x00000040;
              formattedMatchPrice_ = input.readBytes();
              break;
            }
            case 66: {
              bitField0_ |= 0x00000080;
              changeColor_ = input.readBytes();
              break;
            }
            case 74: {
              bitField0_ |= 0x00000100;
              formattedChangeValue_ = input.readBytes();
              break;
            }
            case 82: {
              bitField0_ |= 0x00000200;
              formattedVol_ = input.readBytes();
              break;
            }
            case 90: {
              bitField0_ |= 0x00000400;
              formattedAccVol_ = input.readBytes();
              break;
            }
            case 98: {
              bitField0_ |= 0x00000800;
              formattedAccVal_ = input.readBytes();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.fss.fo.mserver.exchange.TransLogProtos.internal_static_com_fss_fo_mserver_exchange_TransLog_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.fss.fo.mserver.exchange.TransLogProtos.internal_static_com_fss_fo_mserver_exchange_TransLog_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.fss.fo.mserver.exchange.TransLogProtos.TransLog.class, com.fss.fo.mserver.exchange.TransLogProtos.TransLog.Builder.class);
    }

    public static com.google.protobuf.Parser<TransLog> PARSER =
        new com.google.protobuf.AbstractParser<TransLog>() {
      public TransLog parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new TransLog(input, extensionRegistry);
      }
    };

    @java.lang.Override
    public com.google.protobuf.Parser<TransLog> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // optional string Id = 1;
    public static final int ID_FIELD_NUMBER = 1;
    private java.lang.Object id_;
    /**
     * <code>optional string Id = 1;</code>
     */
    public boolean hasId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>optional string Id = 1;</code>
     */
    public java.lang.String getId() {
      java.lang.Object ref = id_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          id_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Id = 1;</code>
     */
    public com.google.protobuf.ByteString
        getIdBytes() {
      java.lang.Object ref = id_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        id_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional int32 sequenceMsg = 2;
    public static final int SEQUENCEMSG_FIELD_NUMBER = 2;
    private int sequenceMsg_;
    /**
     * <code>optional int32 sequenceMsg = 2;</code>
     */
    public boolean hasSequenceMsg() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>optional int32 sequenceMsg = 2;</code>
     */
    public int getSequenceMsg() {
      return sequenceMsg_;
    }

    // optional string tradingdate = 3;
    public static final int TRADINGDATE_FIELD_NUMBER = 3;
    private java.lang.Object tradingdate_;
    /**
     * <code>optional string tradingdate = 3;</code>
     */
    public boolean hasTradingdate() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    /**
     * <code>optional string tradingdate = 3;</code>
     */
    public java.lang.String getTradingdate() {
      java.lang.Object ref = tradingdate_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          tradingdate_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string tradingdate = 3;</code>
     */
    public com.google.protobuf.ByteString
        getTradingdateBytes() {
      java.lang.Object ref = tradingdate_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        tradingdate_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string symbol = 4;
    public static final int SYMBOL_FIELD_NUMBER = 4;
    private java.lang.Object symbol_;
    /**
     * <code>optional string symbol = 4;</code>
     */
    public boolean hasSymbol() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    /**
     * <code>optional string symbol = 4;</code>
     */
    public java.lang.String getSymbol() {
      java.lang.Object ref = symbol_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          symbol_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string symbol = 4;</code>
     */
    public com.google.protobuf.ByteString
        getSymbolBytes() {
      java.lang.Object ref = symbol_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        symbol_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string formattedTime = 5;
    public static final int FORMATTEDTIME_FIELD_NUMBER = 5;
    private java.lang.Object formattedTime_;
    /**
     * <code>optional string formattedTime = 5;</code>
     */
    public boolean hasFormattedTime() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    /**
     * <code>optional string formattedTime = 5;</code>
     */
    public java.lang.String getFormattedTime() {
      java.lang.Object ref = formattedTime_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          formattedTime_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string formattedTime = 5;</code>
     */
    public com.google.protobuf.ByteString
        getFormattedTimeBytes() {
      java.lang.Object ref = formattedTime_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        formattedTime_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string lastColor = 6;
    public static final int LASTCOLOR_FIELD_NUMBER = 6;
    private java.lang.Object lastColor_;
    /**
     * <code>optional string lastColor = 6;</code>
     */
    public boolean hasLastColor() {
      return ((bitField0_ & 0x00000020) == 0x00000020);
    }
    /**
     * <code>optional string lastColor = 6;</code>
     */
    public java.lang.String getLastColor() {
      java.lang.Object ref = lastColor_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          lastColor_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string lastColor = 6;</code>
     */
    public com.google.protobuf.ByteString
        getLastColorBytes() {
      java.lang.Object ref = lastColor_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        lastColor_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string formattedMatchPrice = 7;
    public static final int FORMATTEDMATCHPRICE_FIELD_NUMBER = 7;
    private java.lang.Object formattedMatchPrice_;
    /**
     * <code>optional string formattedMatchPrice = 7;</code>
     */
    public boolean hasFormattedMatchPrice() {
      return ((bitField0_ & 0x00000040) == 0x00000040);
    }
    /**
     * <code>optional string formattedMatchPrice = 7;</code>
     */
    public java.lang.String getFormattedMatchPrice() {
      java.lang.Object ref = formattedMatchPrice_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          formattedMatchPrice_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string formattedMatchPrice = 7;</code>
     */
    public com.google.protobuf.ByteString
        getFormattedMatchPriceBytes() {
      java.lang.Object ref = formattedMatchPrice_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        formattedMatchPrice_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string changeColor = 8;
    public static final int CHANGECOLOR_FIELD_NUMBER = 8;
    private java.lang.Object changeColor_;
    /**
     * <code>optional string changeColor = 8;</code>
     */
    public boolean hasChangeColor() {
      return ((bitField0_ & 0x00000080) == 0x00000080);
    }
    /**
     * <code>optional string changeColor = 8;</code>
     */
    public java.lang.String getChangeColor() {
      java.lang.Object ref = changeColor_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          changeColor_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string changeColor = 8;</code>
     */
    public com.google.protobuf.ByteString
        getChangeColorBytes() {
      java.lang.Object ref = changeColor_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        changeColor_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string formattedChangeValue = 9;
    public static final int FORMATTEDCHANGEVALUE_FIELD_NUMBER = 9;
    private java.lang.Object formattedChangeValue_;
    /**
     * <code>optional string formattedChangeValue = 9;</code>
     */
    public boolean hasFormattedChangeValue() {
      return ((bitField0_ & 0x00000100) == 0x00000100);
    }
    /**
     * <code>optional string formattedChangeValue = 9;</code>
     */
    public java.lang.String getFormattedChangeValue() {
      java.lang.Object ref = formattedChangeValue_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          formattedChangeValue_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string formattedChangeValue = 9;</code>
     */
    public com.google.protobuf.ByteString
        getFormattedChangeValueBytes() {
      java.lang.Object ref = formattedChangeValue_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        formattedChangeValue_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string formattedVol = 10;
    public static final int FORMATTEDVOL_FIELD_NUMBER = 10;
    private java.lang.Object formattedVol_;
    /**
     * <code>optional string formattedVol = 10;</code>
     */
    public boolean hasFormattedVol() {
      return ((bitField0_ & 0x00000200) == 0x00000200);
    }
    /**
     * <code>optional string formattedVol = 10;</code>
     */
    public java.lang.String getFormattedVol() {
      java.lang.Object ref = formattedVol_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          formattedVol_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string formattedVol = 10;</code>
     */
    public com.google.protobuf.ByteString
        getFormattedVolBytes() {
      java.lang.Object ref = formattedVol_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        formattedVol_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string formattedAccVol = 11;
    public static final int FORMATTEDACCVOL_FIELD_NUMBER = 11;
    private java.lang.Object formattedAccVol_;
    /**
     * <code>optional string formattedAccVol = 11;</code>
     */
    public boolean hasFormattedAccVol() {
      return ((bitField0_ & 0x00000400) == 0x00000400);
    }
    /**
     * <code>optional string formattedAccVol = 11;</code>
     */
    public java.lang.String getFormattedAccVol() {
      java.lang.Object ref = formattedAccVol_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          formattedAccVol_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string formattedAccVol = 11;</code>
     */
    public com.google.protobuf.ByteString
        getFormattedAccVolBytes() {
      java.lang.Object ref = formattedAccVol_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        formattedAccVol_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string formattedAccVal = 12;
    public static final int FORMATTEDACCVAL_FIELD_NUMBER = 12;
    private java.lang.Object formattedAccVal_;
    /**
     * <code>optional string formattedAccVal = 12;</code>
     */
    public boolean hasFormattedAccVal() {
      return ((bitField0_ & 0x00000800) == 0x00000800);
    }
    /**
     * <code>optional string formattedAccVal = 12;</code>
     */
    public java.lang.String getFormattedAccVal() {
      java.lang.Object ref = formattedAccVal_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          formattedAccVal_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string formattedAccVal = 12;</code>
     */
    public com.google.protobuf.ByteString
        getFormattedAccValBytes() {
      java.lang.Object ref = formattedAccVal_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        formattedAccVal_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    private void initFields() {
      id_ = "";
      sequenceMsg_ = 0;
      tradingdate_ = "";
      symbol_ = "";
      formattedTime_ = "";
      lastColor_ = "";
      formattedMatchPrice_ = "";
      changeColor_ = "";
      formattedChangeValue_ = "";
      formattedVol_ = "";
      formattedAccVol_ = "";
      formattedAccVal_ = "";
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeBytes(1, getIdBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeInt32(2, sequenceMsg_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeBytes(3, getTradingdateBytes());
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeBytes(4, getSymbolBytes());
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeBytes(5, getFormattedTimeBytes());
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        output.writeBytes(6, getLastColorBytes());
      }
      if (((bitField0_ & 0x00000040) == 0x00000040)) {
        output.writeBytes(7, getFormattedMatchPriceBytes());
      }
      if (((bitField0_ & 0x00000080) == 0x00000080)) {
        output.writeBytes(8, getChangeColorBytes());
      }
      if (((bitField0_ & 0x00000100) == 0x00000100)) {
        output.writeBytes(9, getFormattedChangeValueBytes());
      }
      if (((bitField0_ & 0x00000200) == 0x00000200)) {
        output.writeBytes(10, getFormattedVolBytes());
      }
      if (((bitField0_ & 0x00000400) == 0x00000400)) {
        output.writeBytes(11, getFormattedAccVolBytes());
      }
      if (((bitField0_ & 0x00000800) == 0x00000800)) {
        output.writeBytes(12, getFormattedAccValBytes());
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(1, getIdBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, sequenceMsg_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(3, getTradingdateBytes());
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(4, getSymbolBytes());
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(5, getFormattedTimeBytes());
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(6, getLastColorBytes());
      }
      if (((bitField0_ & 0x00000040) == 0x00000040)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(7, getFormattedMatchPriceBytes());
      }
      if (((bitField0_ & 0x00000080) == 0x00000080)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(8, getChangeColorBytes());
      }
      if (((bitField0_ & 0x00000100) == 0x00000100)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(9, getFormattedChangeValueBytes());
      }
      if (((bitField0_ & 0x00000200) == 0x00000200)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(10, getFormattedVolBytes());
      }
      if (((bitField0_ & 0x00000400) == 0x00000400)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(11, getFormattedAccVolBytes());
      }
      if (((bitField0_ & 0x00000800) == 0x00000800)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(12, getFormattedAccValBytes());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    public static com.fss.fo.mserver.exchange.TransLogProtos.TransLog parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.fss.fo.mserver.exchange.TransLogProtos.TransLog parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.TransLogProtos.TransLog parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.fss.fo.mserver.exchange.TransLogProtos.TransLog parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.TransLogProtos.TransLog parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static com.fss.fo.mserver.exchange.TransLogProtos.TransLog parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.TransLogProtos.TransLog parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static com.fss.fo.mserver.exchange.TransLogProtos.TransLog parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.TransLogProtos.TransLog parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static com.fss.fo.mserver.exchange.TransLogProtos.TransLog parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(com.fss.fo.mserver.exchange.TransLogProtos.TransLog prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code com.fss.fo.mserver.exchange.TransLog}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements com.fss.fo.mserver.exchange.TransLogProtos.TransLogOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.fss.fo.mserver.exchange.TransLogProtos.internal_static_com_fss_fo_mserver_exchange_TransLog_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.fss.fo.mserver.exchange.TransLogProtos.internal_static_com_fss_fo_mserver_exchange_TransLog_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.fss.fo.mserver.exchange.TransLogProtos.TransLog.class, com.fss.fo.mserver.exchange.TransLogProtos.TransLog.Builder.class);
      }

      // Construct using com.fss.fo.mserver.exchange.TransLogProtos.TransLog.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        id_ = "";
        bitField0_ = (bitField0_ & ~0x00000001);
        sequenceMsg_ = 0;
        bitField0_ = (bitField0_ & ~0x00000002);
        tradingdate_ = "";
        bitField0_ = (bitField0_ & ~0x00000004);
        symbol_ = "";
        bitField0_ = (bitField0_ & ~0x00000008);
        formattedTime_ = "";
        bitField0_ = (bitField0_ & ~0x00000010);
        lastColor_ = "";
        bitField0_ = (bitField0_ & ~0x00000020);
        formattedMatchPrice_ = "";
        bitField0_ = (bitField0_ & ~0x00000040);
        changeColor_ = "";
        bitField0_ = (bitField0_ & ~0x00000080);
        formattedChangeValue_ = "";
        bitField0_ = (bitField0_ & ~0x00000100);
        formattedVol_ = "";
        bitField0_ = (bitField0_ & ~0x00000200);
        formattedAccVol_ = "";
        bitField0_ = (bitField0_ & ~0x00000400);
        formattedAccVal_ = "";
        bitField0_ = (bitField0_ & ~0x00000800);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.fss.fo.mserver.exchange.TransLogProtos.internal_static_com_fss_fo_mserver_exchange_TransLog_descriptor;
      }

      public com.fss.fo.mserver.exchange.TransLogProtos.TransLog getDefaultInstanceForType() {
        return com.fss.fo.mserver.exchange.TransLogProtos.TransLog.getDefaultInstance();
      }

      public com.fss.fo.mserver.exchange.TransLogProtos.TransLog build() {
        com.fss.fo.mserver.exchange.TransLogProtos.TransLog result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public com.fss.fo.mserver.exchange.TransLogProtos.TransLog buildPartial() {
        com.fss.fo.mserver.exchange.TransLogProtos.TransLog result = new com.fss.fo.mserver.exchange.TransLogProtos.TransLog(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.id_ = id_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.sequenceMsg_ = sequenceMsg_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.tradingdate_ = tradingdate_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.symbol_ = symbol_;
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000010;
        }
        result.formattedTime_ = formattedTime_;
        if (((from_bitField0_ & 0x00000020) == 0x00000020)) {
          to_bitField0_ |= 0x00000020;
        }
        result.lastColor_ = lastColor_;
        if (((from_bitField0_ & 0x00000040) == 0x00000040)) {
          to_bitField0_ |= 0x00000040;
        }
        result.formattedMatchPrice_ = formattedMatchPrice_;
        if (((from_bitField0_ & 0x00000080) == 0x00000080)) {
          to_bitField0_ |= 0x00000080;
        }
        result.changeColor_ = changeColor_;
        if (((from_bitField0_ & 0x00000100) == 0x00000100)) {
          to_bitField0_ |= 0x00000100;
        }
        result.formattedChangeValue_ = formattedChangeValue_;
        if (((from_bitField0_ & 0x00000200) == 0x00000200)) {
          to_bitField0_ |= 0x00000200;
        }
        result.formattedVol_ = formattedVol_;
        if (((from_bitField0_ & 0x00000400) == 0x00000400)) {
          to_bitField0_ |= 0x00000400;
        }
        result.formattedAccVol_ = formattedAccVol_;
        if (((from_bitField0_ & 0x00000800) == 0x00000800)) {
          to_bitField0_ |= 0x00000800;
        }
        result.formattedAccVal_ = formattedAccVal_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.fss.fo.mserver.exchange.TransLogProtos.TransLog) {
          return mergeFrom((com.fss.fo.mserver.exchange.TransLogProtos.TransLog)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.fss.fo.mserver.exchange.TransLogProtos.TransLog other) {
        if (other == com.fss.fo.mserver.exchange.TransLogProtos.TransLog.getDefaultInstance()) return this;
        if (other.hasId()) {
          bitField0_ |= 0x00000001;
          id_ = other.id_;
          onChanged();
        }
        if (other.hasSequenceMsg()) {
          setSequenceMsg(other.getSequenceMsg());
        }
        if (other.hasTradingdate()) {
          bitField0_ |= 0x00000004;
          tradingdate_ = other.tradingdate_;
          onChanged();
        }
        if (other.hasSymbol()) {
          bitField0_ |= 0x00000008;
          symbol_ = other.symbol_;
          onChanged();
        }
        if (other.hasFormattedTime()) {
          bitField0_ |= 0x00000010;
          formattedTime_ = other.formattedTime_;
          onChanged();
        }
        if (other.hasLastColor()) {
          bitField0_ |= 0x00000020;
          lastColor_ = other.lastColor_;
          onChanged();
        }
        if (other.hasFormattedMatchPrice()) {
          bitField0_ |= 0x00000040;
          formattedMatchPrice_ = other.formattedMatchPrice_;
          onChanged();
        }
        if (other.hasChangeColor()) {
          bitField0_ |= 0x00000080;
          changeColor_ = other.changeColor_;
          onChanged();
        }
        if (other.hasFormattedChangeValue()) {
          bitField0_ |= 0x00000100;
          formattedChangeValue_ = other.formattedChangeValue_;
          onChanged();
        }
        if (other.hasFormattedVol()) {
          bitField0_ |= 0x00000200;
          formattedVol_ = other.formattedVol_;
          onChanged();
        }
        if (other.hasFormattedAccVol()) {
          bitField0_ |= 0x00000400;
          formattedAccVol_ = other.formattedAccVol_;
          onChanged();
        }
        if (other.hasFormattedAccVal()) {
          bitField0_ |= 0x00000800;
          formattedAccVal_ = other.formattedAccVal_;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.fss.fo.mserver.exchange.TransLogProtos.TransLog parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (com.fss.fo.mserver.exchange.TransLogProtos.TransLog) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // optional string Id = 1;
      private java.lang.Object id_ = "";
      /**
       * <code>optional string Id = 1;</code>
       */
      public boolean hasId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public java.lang.String getId() {
        java.lang.Object ref = id_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          id_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public com.google.protobuf.ByteString
          getIdBytes() {
        java.lang.Object ref = id_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          id_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder setId(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        id_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder clearId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        id_ = getDefaultInstance().getId();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder setIdBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        id_ = value;
        onChanged();
        return this;
      }

      // optional int32 sequenceMsg = 2;
      private int sequenceMsg_ ;
      /**
       * <code>optional int32 sequenceMsg = 2;</code>
       */
      public boolean hasSequenceMsg() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>optional int32 sequenceMsg = 2;</code>
       */
      public int getSequenceMsg() {
        return sequenceMsg_;
      }
      /**
       * <code>optional int32 sequenceMsg = 2;</code>
       */
      public Builder setSequenceMsg(int value) {
        bitField0_ |= 0x00000002;
        sequenceMsg_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional int32 sequenceMsg = 2;</code>
       */
      public Builder clearSequenceMsg() {
        bitField0_ = (bitField0_ & ~0x00000002);
        sequenceMsg_ = 0;
        onChanged();
        return this;
      }

      // optional string tradingdate = 3;
      private java.lang.Object tradingdate_ = "";
      /**
       * <code>optional string tradingdate = 3;</code>
       */
      public boolean hasTradingdate() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      /**
       * <code>optional string tradingdate = 3;</code>
       */
      public java.lang.String getTradingdate() {
        java.lang.Object ref = tradingdate_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          tradingdate_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string tradingdate = 3;</code>
       */
      public com.google.protobuf.ByteString
          getTradingdateBytes() {
        java.lang.Object ref = tradingdate_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          tradingdate_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string tradingdate = 3;</code>
       */
      public Builder setTradingdate(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        tradingdate_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string tradingdate = 3;</code>
       */
      public Builder clearTradingdate() {
        bitField0_ = (bitField0_ & ~0x00000004);
        tradingdate_ = getDefaultInstance().getTradingdate();
        onChanged();
        return this;
      }
      /**
       * <code>optional string tradingdate = 3;</code>
       */
      public Builder setTradingdateBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        tradingdate_ = value;
        onChanged();
        return this;
      }

      // optional string symbol = 4;
      private java.lang.Object symbol_ = "";
      /**
       * <code>optional string symbol = 4;</code>
       */
      public boolean hasSymbol() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      /**
       * <code>optional string symbol = 4;</code>
       */
      public java.lang.String getSymbol() {
        java.lang.Object ref = symbol_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          symbol_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string symbol = 4;</code>
       */
      public com.google.protobuf.ByteString
          getSymbolBytes() {
        java.lang.Object ref = symbol_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          symbol_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string symbol = 4;</code>
       */
      public Builder setSymbol(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000008;
        symbol_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string symbol = 4;</code>
       */
      public Builder clearSymbol() {
        bitField0_ = (bitField0_ & ~0x00000008);
        symbol_ = getDefaultInstance().getSymbol();
        onChanged();
        return this;
      }
      /**
       * <code>optional string symbol = 4;</code>
       */
      public Builder setSymbolBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000008;
        symbol_ = value;
        onChanged();
        return this;
      }

      // optional string formattedTime = 5;
      private java.lang.Object formattedTime_ = "";
      /**
       * <code>optional string formattedTime = 5;</code>
       */
      public boolean hasFormattedTime() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      /**
       * <code>optional string formattedTime = 5;</code>
       */
      public java.lang.String getFormattedTime() {
        java.lang.Object ref = formattedTime_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          formattedTime_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string formattedTime = 5;</code>
       */
      public com.google.protobuf.ByteString
          getFormattedTimeBytes() {
        java.lang.Object ref = formattedTime_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          formattedTime_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string formattedTime = 5;</code>
       */
      public Builder setFormattedTime(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000010;
        formattedTime_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string formattedTime = 5;</code>
       */
      public Builder clearFormattedTime() {
        bitField0_ = (bitField0_ & ~0x00000010);
        formattedTime_ = getDefaultInstance().getFormattedTime();
        onChanged();
        return this;
      }
      /**
       * <code>optional string formattedTime = 5;</code>
       */
      public Builder setFormattedTimeBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000010;
        formattedTime_ = value;
        onChanged();
        return this;
      }

      // optional string lastColor = 6;
      private java.lang.Object lastColor_ = "";
      /**
       * <code>optional string lastColor = 6;</code>
       */
      public boolean hasLastColor() {
        return ((bitField0_ & 0x00000020) == 0x00000020);
      }
      /**
       * <code>optional string lastColor = 6;</code>
       */
      public java.lang.String getLastColor() {
        java.lang.Object ref = lastColor_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          lastColor_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string lastColor = 6;</code>
       */
      public com.google.protobuf.ByteString
          getLastColorBytes() {
        java.lang.Object ref = lastColor_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          lastColor_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string lastColor = 6;</code>
       */
      public Builder setLastColor(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
        lastColor_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string lastColor = 6;</code>
       */
      public Builder clearLastColor() {
        bitField0_ = (bitField0_ & ~0x00000020);
        lastColor_ = getDefaultInstance().getLastColor();
        onChanged();
        return this;
      }
      /**
       * <code>optional string lastColor = 6;</code>
       */
      public Builder setLastColorBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
        lastColor_ = value;
        onChanged();
        return this;
      }

      // optional string formattedMatchPrice = 7;
      private java.lang.Object formattedMatchPrice_ = "";
      /**
       * <code>optional string formattedMatchPrice = 7;</code>
       */
      public boolean hasFormattedMatchPrice() {
        return ((bitField0_ & 0x00000040) == 0x00000040);
      }
      /**
       * <code>optional string formattedMatchPrice = 7;</code>
       */
      public java.lang.String getFormattedMatchPrice() {
        java.lang.Object ref = formattedMatchPrice_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          formattedMatchPrice_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string formattedMatchPrice = 7;</code>
       */
      public com.google.protobuf.ByteString
          getFormattedMatchPriceBytes() {
        java.lang.Object ref = formattedMatchPrice_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          formattedMatchPrice_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string formattedMatchPrice = 7;</code>
       */
      public Builder setFormattedMatchPrice(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000040;
        formattedMatchPrice_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string formattedMatchPrice = 7;</code>
       */
      public Builder clearFormattedMatchPrice() {
        bitField0_ = (bitField0_ & ~0x00000040);
        formattedMatchPrice_ = getDefaultInstance().getFormattedMatchPrice();
        onChanged();
        return this;
      }
      /**
       * <code>optional string formattedMatchPrice = 7;</code>
       */
      public Builder setFormattedMatchPriceBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000040;
        formattedMatchPrice_ = value;
        onChanged();
        return this;
      }

      // optional string changeColor = 8;
      private java.lang.Object changeColor_ = "";
      /**
       * <code>optional string changeColor = 8;</code>
       */
      public boolean hasChangeColor() {
        return ((bitField0_ & 0x00000080) == 0x00000080);
      }
      /**
       * <code>optional string changeColor = 8;</code>
       */
      public java.lang.String getChangeColor() {
        java.lang.Object ref = changeColor_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          changeColor_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string changeColor = 8;</code>
       */
      public com.google.protobuf.ByteString
          getChangeColorBytes() {
        java.lang.Object ref = changeColor_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          changeColor_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string changeColor = 8;</code>
       */
      public Builder setChangeColor(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000080;
        changeColor_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string changeColor = 8;</code>
       */
      public Builder clearChangeColor() {
        bitField0_ = (bitField0_ & ~0x00000080);
        changeColor_ = getDefaultInstance().getChangeColor();
        onChanged();
        return this;
      }
      /**
       * <code>optional string changeColor = 8;</code>
       */
      public Builder setChangeColorBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000080;
        changeColor_ = value;
        onChanged();
        return this;
      }

      // optional string formattedChangeValue = 9;
      private java.lang.Object formattedChangeValue_ = "";
      /**
       * <code>optional string formattedChangeValue = 9;</code>
       */
      public boolean hasFormattedChangeValue() {
        return ((bitField0_ & 0x00000100) == 0x00000100);
      }
      /**
       * <code>optional string formattedChangeValue = 9;</code>
       */
      public java.lang.String getFormattedChangeValue() {
        java.lang.Object ref = formattedChangeValue_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          formattedChangeValue_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string formattedChangeValue = 9;</code>
       */
      public com.google.protobuf.ByteString
          getFormattedChangeValueBytes() {
        java.lang.Object ref = formattedChangeValue_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          formattedChangeValue_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string formattedChangeValue = 9;</code>
       */
      public Builder setFormattedChangeValue(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000100;
        formattedChangeValue_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string formattedChangeValue = 9;</code>
       */
      public Builder clearFormattedChangeValue() {
        bitField0_ = (bitField0_ & ~0x00000100);
        formattedChangeValue_ = getDefaultInstance().getFormattedChangeValue();
        onChanged();
        return this;
      }
      /**
       * <code>optional string formattedChangeValue = 9;</code>
       */
      public Builder setFormattedChangeValueBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000100;
        formattedChangeValue_ = value;
        onChanged();
        return this;
      }

      // optional string formattedVol = 10;
      private java.lang.Object formattedVol_ = "";
      /**
       * <code>optional string formattedVol = 10;</code>
       */
      public boolean hasFormattedVol() {
        return ((bitField0_ & 0x00000200) == 0x00000200);
      }
      /**
       * <code>optional string formattedVol = 10;</code>
       */
      public java.lang.String getFormattedVol() {
        java.lang.Object ref = formattedVol_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          formattedVol_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string formattedVol = 10;</code>
       */
      public com.google.protobuf.ByteString
          getFormattedVolBytes() {
        java.lang.Object ref = formattedVol_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          formattedVol_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string formattedVol = 10;</code>
       */
      public Builder setFormattedVol(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000200;
        formattedVol_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string formattedVol = 10;</code>
       */
      public Builder clearFormattedVol() {
        bitField0_ = (bitField0_ & ~0x00000200);
        formattedVol_ = getDefaultInstance().getFormattedVol();
        onChanged();
        return this;
      }
      /**
       * <code>optional string formattedVol = 10;</code>
       */
      public Builder setFormattedVolBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000200;
        formattedVol_ = value;
        onChanged();
        return this;
      }

      // optional string formattedAccVol = 11;
      private java.lang.Object formattedAccVol_ = "";
      /**
       * <code>optional string formattedAccVol = 11;</code>
       */
      public boolean hasFormattedAccVol() {
        return ((bitField0_ & 0x00000400) == 0x00000400);
      }
      /**
       * <code>optional string formattedAccVol = 11;</code>
       */
      public java.lang.String getFormattedAccVol() {
        java.lang.Object ref = formattedAccVol_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          formattedAccVol_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string formattedAccVol = 11;</code>
       */
      public com.google.protobuf.ByteString
          getFormattedAccVolBytes() {
        java.lang.Object ref = formattedAccVol_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          formattedAccVol_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string formattedAccVol = 11;</code>
       */
      public Builder setFormattedAccVol(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000400;
        formattedAccVol_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string formattedAccVol = 11;</code>
       */
      public Builder clearFormattedAccVol() {
        bitField0_ = (bitField0_ & ~0x00000400);
        formattedAccVol_ = getDefaultInstance().getFormattedAccVol();
        onChanged();
        return this;
      }
      /**
       * <code>optional string formattedAccVol = 11;</code>
       */
      public Builder setFormattedAccVolBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000400;
        formattedAccVol_ = value;
        onChanged();
        return this;
      }

      // optional string formattedAccVal = 12;
      private java.lang.Object formattedAccVal_ = "";
      /**
       * <code>optional string formattedAccVal = 12;</code>
       */
      public boolean hasFormattedAccVal() {
        return ((bitField0_ & 0x00000800) == 0x00000800);
      }
      /**
       * <code>optional string formattedAccVal = 12;</code>
       */
      public java.lang.String getFormattedAccVal() {
        java.lang.Object ref = formattedAccVal_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          formattedAccVal_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string formattedAccVal = 12;</code>
       */
      public com.google.protobuf.ByteString
          getFormattedAccValBytes() {
        java.lang.Object ref = formattedAccVal_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          formattedAccVal_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string formattedAccVal = 12;</code>
       */
      public Builder setFormattedAccVal(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000800;
        formattedAccVal_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string formattedAccVal = 12;</code>
       */
      public Builder clearFormattedAccVal() {
        bitField0_ = (bitField0_ & ~0x00000800);
        formattedAccVal_ = getDefaultInstance().getFormattedAccVal();
        onChanged();
        return this;
      }
      /**
       * <code>optional string formattedAccVal = 12;</code>
       */
      public Builder setFormattedAccValBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000800;
        formattedAccVal_ = value;
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:com.fss.fo.mserver.exchange.TransLog)
    }

    static {
      defaultInstance = new TransLog(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:com.fss.fo.mserver.exchange.TransLog)
  }

  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_com_fss_fo_mserver_exchange_TransLog_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_com_fss_fo_mserver_exchange_TransLog_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\016TransLog.proto\022\033com.fss.fo.mserver.exc" +
      "hange\"\222\002\n\010TransLog\022\n\n\002Id\030\001 \001(\t\022\023\n\013sequen" +
      "ceMsg\030\002 \001(\005\022\023\n\013tradingdate\030\003 \001(\t\022\016\n\006symb" +
      "ol\030\004 \001(\t\022\025\n\rformattedTime\030\005 \001(\t\022\021\n\tlastC" +
      "olor\030\006 \001(\t\022\033\n\023formattedMatchPrice\030\007 \001(\t\022" +
      "\023\n\013changeColor\030\010 \001(\t\022\034\n\024formattedChangeV" +
      "alue\030\t \001(\t\022\024\n\014formattedVol\030\n \001(\t\022\027\n\017form" +
      "attedAccVol\030\013 \001(\t\022\027\n\017formattedAccVal\030\014 \001" +
      "(\tB-\n\033com.fss.fo.mserver.exchangeB\016Trans" +
      "LogProtos"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_com_fss_fo_mserver_exchange_TransLog_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_com_fss_fo_mserver_exchange_TransLog_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_com_fss_fo_mserver_exchange_TransLog_descriptor,
              new java.lang.String[] { "Id", "SequenceMsg", "Tradingdate", "Symbol", "FormattedTime", "LastColor", "FormattedMatchPrice", "ChangeColor", "FormattedChangeValue", "FormattedVol", "FormattedAccVol", "FormattedAccVal", });
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }

  // @@protoc_insertion_point(outer_class_scope)
}
